#include <stdbool.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>

bool common_case(bool cond);
#define uncommon_case(cond) (!common_case(!cond))

#define fast_path_when common_case
#define slow_path_when uncommon_case

int my_algo(bool cond) {
  if (common_case(cond)) {
    // fibonacci from 0 to 100
    int a = 0;
    int b = 1;
    int c = 0;
    for (int i = 0; i < 100; i++) {
      printf("%d ", a);
      c = a + b;
      a = b;
      b = c;
    }
    printf("\n");
    return c;
  } else {
    // prime numbers from 0 to 100
    int prime = 0;
    for (int i = 2; i < 100; i++) {
      bool is_prime = true;
      for (int j = 2; j < i; j++) {
        if (i % j == 0) {
          is_prime = false;
          break;
        }
      }
      if (is_prime) {
        printf("%d ", i);
        prime = i;
      }
    }
    printf("\n");
    return prime;
  }
}

uint32_t compute_mask();

int my_inst(bool mask_cond, bool other_cond) {
  uint32_t mask = fast_path_when(mask_cond) ? 0xFFFFFFFF : compute_mask();

  // compute fibonacci but mask out each intermediate result
  uint32_t a = 0;
  uint32_t b = 1;
  uint32_t c = 0;
  for (int i = 0; i < 100; i++) {
    printf("%d ", a & mask);
    c = (a & mask) + b;
    a = b;
    b = c;
  }

  if (uncommon_case(other_cond)) {
    printf("lol rip\n");
  }

  printf("\n");
  return c;
}
